Bug 1897607 - python-lzo fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats
Summary: python-lzo fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN mac...
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: python-lzo
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Huzaifa S. Sidhpurwala
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-13 15:58 UTC by Tomáš Hrnčiar
Modified: 2021-02-09 16:23 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-11-13 15:58:00 UTC
python-lzo fails to build with Python 3.10.0a2.

Python bindings for the LZO data compression library
SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/builddir/build/BUILD/python-lzo-1.09/tests/./test.py", line 104, in <module>
    sys.exit(main(sys.argv))
  File "/builddir/build/BUILD/python-lzo-1.09/tests/./test.py", line 86, in main
    test(b"aaaaaaaaaaaaaaaaaaaaaaaa")
  File "/builddir/build/BUILD/python-lzo-1.09/tests/./test.py", line 58, in test
    a0 = lzo.adler32(src)
SystemError: <built-in function adler32> returned a result with an error set

https://docs.python.org/3.10/whatsnew/3.10.html#id2

The PY_SSIZE_T_CLEAN macro must now be defined to use PyArg_ParseTuple() and Py_BuildValue() formats which use #: es#, et#, s#, u#, y#, z#, U# and Z#. See Parsing arguments and building values and the PEP 353.
https://docs.python.org/3.10/c-api/arg.html#arg-parsing
https://www.python.org/dev/peps/pep-0353
https://bugs.python.org/issue40943

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01758256-python-lzo/

For all our attempts to build python-lzo with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-lzo/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Ben Cotton 2021-02-09 15:24:16 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.


Note You need to log in before you can comment on or make changes to this bug.